package com.mysticlightsstudios.azurepushnotification

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.os.PersistableBundle
import android.util.Log
import androidx.annotation.NonNull;
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import com.google.android.gms.common.ConnectionResult
import com.google.android.gms.common.GoogleApiAvailability
import io.flutter.app.FlutterActivity


/** AzurepushnotificationPlugin */
class AzurepushnotificationPlugin: FlutterPlugin, MethodCallHandler, FlutterActivity() {

  private var PLAY_SERVICES_RESOLUTION_REQUEST = 9000
  private lateinit var application: Context

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    val channel = MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "azurepushnotification")
    channel.setMethodCallHandler(this)
    application = flutterPluginBinding.applicationContext
  }

  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "azurepushnotification")
      channel.setMethodCallHandler(this)

    }
  }


  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {

    if(call.method == "azurePushNotification"){

        var tag = call.argument<String>("id")
        var hubName = call.argument<String>("hubName")
        var connectionString = call.argument<String>("HubListenConnectionString")

        NotificationSettings.HubName = hubName!!
        NotificationSettings.HubListenConnectionString = connectionString!!


      registerWithNotificationHubs(tag!!)
    } else {
      result.notImplemented()
    }
  }

  fun registerWithNotificationHubs(tag: String) {
    if (checkPlayServices()) {
      // Start IntentService to register this application with FCM.
      val intent = Intent(application, RegistrationIntentService::class.java)
      intent.putExtra("tag", tag)
      application.startService(intent)
      //FirebaseService.createChannelAndHandleNotifications(application.applicationContext, this)

    }
  }

  private fun checkPlayServices(): Boolean {
    val apiAvailability = GoogleApiAvailability.getInstance()
    val resultCode = apiAvailability.isGooglePlayServicesAvailable(application.applicationContext)
    if (resultCode != ConnectionResult.SUCCESS) {
      if (apiAvailability.isUserResolvableError(resultCode)) {
        apiAvailability.getErrorDialog(this, resultCode, PLAY_SERVICES_RESOLUTION_REQUEST)
                .show()
      } else {
        Log.i("AzureNotificationPlugin", "This device is not supported by Google Play Services.")
        finish()
      }
      return false
    }
    return true
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
  }
}

private fun MethodChannel.setMethodCallHandler(companion: AzurepushnotificationPlugin.Companion) {

}
