package com.mysticlightsstudios.azurepushnotification

import android.app.Activity
import android.app.NotificationChannel
import android.app.NotificationManager
import android.app.PendingIntent
import android.os.Build.VERSION_CODES.O
import android.os.Build.VERSION.SDK_INT
import android.media.RingtoneManager.TYPE_NOTIFICATION
import android.media.RingtoneManager.getDefaultUri
import android.app.PendingIntent.FLAG_ONE_SHOT
import android.content.Context
import android.content.Intent
import android.content.Intent.FLAG_ACTIVITY_CLEAR_TOP
import android.os.Build
import android.util.Log
import com.google.firebase.messaging.RemoteMessage
import com.google.firebase.messaging.FirebaseMessagingService
import androidx.core.app.NotificationCompat


class FirebaseService : FirebaseMessagingService() {
    private val TAG = "FirebaseService"
    private var mNotificationManager: NotificationManager? = null
    internal var builder: NotificationCompat.Builder? = null


    override fun onMessageReceived(remoteMessage: RemoteMessage) {
        // ...

        // TODO(developer): Handle FCM messages here.
        // Not getting messages here? See why this may be: https://goo.gl/39bRNJ


        val nhMessage: String?
        // Check if message contains a notification payload.
        if (remoteMessage.notification != null) {
            Log.d(TAG, "Message Notification Body: " + remoteMessage.notification!!.body!!)

            nhMessage = remoteMessage.notification!!.body
        } else {
            nhMessage = remoteMessage.data.values.iterator().next()
        }

        // Also if you intend on generating your own notifications as a result of a received FCM
        // message, here is where that should be initiated. See sendNotification method below.
//        if (MainActivity.isVisible!!) {
//            MainActivity.mainActivity!!.ToastNotify(nhMessage)
//        }



        sendNotification(nhMessage)


    }

    private fun sendNotification(msg: String?) {

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            val name = NOTIFICATION_CHANNEL_NAME
            val descriptionText = NOTIFICATION_CHANNEL_DESCRIPTION
            val importance = NotificationManager.IMPORTANCE_DEFAULT
            val channel = NotificationChannel(NOTIFICATION_CHANNEL_ID, name, importance).apply {
                description = descriptionText
            }
            // Register the channel with the system
            val notificationManager: NotificationManager =
                    getSystemService(Context.NOTIFICATION_SERVICE) as NotificationManager
            notificationManager.createNotificationChannel(channel)
        }

        val intent = Intent(ctx, activity::class.java)
        intent.addFlags(FLAG_ACTIVITY_CLEAR_TOP)

        mNotificationManager = applicationContext.getSystemService(Context.NOTIFICATION_SERVICE) as NotificationManager

        val contentIntent = PendingIntent.getActivity(applicationContext, 0,
                intent, FLAG_ONE_SHOT)

        val defaultSoundUri = getDefaultUri(TYPE_NOTIFICATION)
        val notificationBuilder = NotificationCompat.Builder(
                applicationContext,
                NOTIFICATION_CHANNEL_ID)
                .setContentText(msg)
                .setPriority(NotificationCompat.PRIORITY_HIGH)
                .setSmallIcon(android.R.drawable.ic_popup_reminder)
                .setBadgeIconType(NotificationCompat.BADGE_ICON_SMALL).setSound(defaultSoundUri)

        notificationBuilder.setContentIntent(contentIntent)
        mNotificationManager!!.notify(NOTIFICATION_ID, notificationBuilder.build())
        Log.d(TAG, "From: $msg")
    }

    companion object {

        val NOTIFICATION_CHANNEL_ID = "nh-demo-channel-id"
        val NOTIFICATION_CHANNEL_NAME = "Notification Hubs Demo Channel"
        val NOTIFICATION_CHANNEL_DESCRIPTION = "Notification Hubs Demo Channel"

        val NOTIFICATION_ID = 1
        internal lateinit var ctx: Context
        internal lateinit var activity: Activity

        fun createChannelAndHandleNotifications(context: Context, act: Activity) {
            ctx = context
            activity = act

            if (SDK_INT >= O) {
                val channel = NotificationChannel(
                        NOTIFICATION_CHANNEL_ID,
                        NOTIFICATION_CHANNEL_NAME,
                        NotificationManager.IMPORTANCE_HIGH)
                channel.description = NOTIFICATION_CHANNEL_DESCRIPTION
                channel.setShowBadge(true)

                val notificationManager = context.getSystemService(NotificationManager::class.java)
                notificationManager.createNotificationChannel(channel)
            }
        }
    }
}